var gMainBox, gHeight, gScreenX, gScreenY, gPanel, gPanelName, gEnableState, gTabbrowser, gDocument;
var hPrefWindow = null;
	  
function Startup()
{
  gMainBox = window.arguments[0];
  gScreenX = gMainBox.screenX;
  gScreenY = gMainBox.screenY;
  gHeight = (gMainBox.innerHeight / 50 - 2)
  gPanel = gMainBox.dialogType;

  var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
                                .getService(Components.interfaces.nsIWindowMediator);
  gTabbrowser = windowManager.getMostRecentWindow("navigator:browser").getBrowser();
  gDocument = gTabbrowser.contentDocument;

  document.documentElement.setAttribute("hidechrome", "true");
  window.outerWidth = gMainBox.innerWidth;
  window.outerHeight = 0;
  window.moveTo(screenX, screenY);

  hPrefWindow = new nsPrefWindow('panelFrame');  
    
  if (!hPrefWindow)
    throw "Permissions Manager Failed to Create its Pref Window";
  hPrefWindow.init();
  document.getElementById(hPrefWindow.contentFrame).setAttribute("tag", gPanel);
  switchPanel(gPanel);
  slideOpen(0);
}

function slideOpen(aStep)
{
  if (aStep < gHeight) {
    window.outerHeight += 50;
    setTimeout(slideOpen, 20, ++aStep);
  } else {
    window.outerHeight = gMainBox.innerHeight;
    document.getElementById("main-box").collapsed = false;
  }
}

function slideClosed(aStep)
{
  if (aStep < gHeight) {
    window.outerHeight -= 50;
    setTimeout(slideClosed, 10, ++aStep);
  } else {
    window.close();
  }
}

function preExitCall(aEvent)
{
  document.getElementById("main-box").collapsed = true;
  gMainBox.switchTree(gPanel);
  slideClosed(0);
}

function onAccept(aEvent)
{
  preExitCall();
  hPrefWindow.onOK(aEvent);
}

function onCancel(aEvent)
{
  preExitCall();
  hPrefWindow.onCancel(aEvent);
}

function initPanel()
{ 
  for (i in gMainBox.permissionTypes) {
    if (gMainBox.permissionTypes[i] == gPanel)
      break;
  }
  gPanelName = gMainBox.capabilityTextID[i];
  var headertitle = window.frames[hPrefWindow.contentFrame].document.getElementsByAttribute("headertitle", "*");
  headertitle[0].setAttribute("headertitle", gMainBox.capabilityTextID[i]);

  if (hPrefWindow)
    hPrefWindow.onpageload(gPanel);
  else
    queuedTag = gPanel;

  document.getElementById('cookie').disabled = true;
  document.getElementById('popup').disabled = true;
}

function closePanel()
{ 
  document.getElementById('cookie').disabled = false;
  document.getElementById('popup').disabled = false;
}

function switchPanel(aPanel)
{
  gPanel = aPanel;
  var panelURL = "chrome://multiviews/content/pref/pref-multiviews-permission-manager.xul";
  // Remember pref panel settings
  var currentPanel = document.getElementById(hPrefWindow.contentFrame).getAttribute("tag");
  hPrefWindow.wsm.savePageData(currentPanel, null);
  document.getElementById(hPrefWindow.contentFrame).setAttribute("tag", gPanel);
  // Reload/reinitialize pref panel
  document.getElementById(hPrefWindow.contentFrame).removeAttribute("src");
  document.getElementById(hPrefWindow.contentFrame).setAttribute("src", panelURL);
  // Select category button
  var button = document.getElementById(aPanel);
  button.checked = true;
  button.focus();
}

function doHelpButton()
{
  gTabbrowser.loadURI("http://multizilla.mozdev.org/features/permission-manager.html#prefsettings");
}